#include-once
#include <Constants.au3>


; --- $MDINEXTMENU
Global Const $MDINEXTMENU = _
	'ptr hmenuIn;'& _
	'ptr hmenuNext;'& _
	'hwnd hwndNext;'


; --- $MENUBARINFO
Global Const $MENUBARINFO = _
	'dword cbSize;'& _
	'long  rcBar [4];'& _
	'ptr   hMenu;'& _
	'hwnd  hwndMenu;'& _
	'int   fBarFocused;'	; Bit 1 fBarFocused; Bit 2 fFocused


; --- $MENUEX_TEMPLATE_HEADER
Global Const $MENUEX_TEMPLATE_HEADER = _
	'ushort wVersion;'& _
	'ushort wOffset;'& _
	'dword dwHelpId;'


; --- $MENUEX_TEMPLATE_ITEM
Global Const $MENUEX_TEMPLATE_ITEM = _
	'dword dwHelpId;'& _
	'dword dwType;'& _
	'dword dwState;'& _
	'dword menuId;'& _
	'ushort bResInfo;'& _
	'wchar szText [2];'; Lnge muss angepasst werden !!!


; --- $MENUGETOBJECTINFO
Global Const $MENUGETOBJECTINFO = _
	'dword dwFlags;'& _
	'uint uPos;'& _
	'ptr hmenu;'& _
	'ptr riid;'& _
	'ptr pvObj;'


; --- $MENUINFO
Global Const $MENUINFO = _
	'dword cbSize;'& _
	'dword fMask;'& _
	'dword dwStyle;'& _
	'uint cyMax;'& _
	'ptr hbrBack;'& _
	'dword dwContextHelpID;'& _
	'ulong_ptr dwMenuData;'


; --- $MENUITEMINFO
Global Const $MENUITEMINFO = _
	'uint cbSize;'& _
	'uint fMask;'& _
	'uint fType;'& _
	'uint fState;'& _
	'uint wID;'& _
	'ptr hSubMenu;'& _
	'ptr hbmpChecked;'& _
	'ptr hbmpUnchecked;'& _
	'ulong_ptr dwItemData;'& _
	'ptr dwTypeData;'& _
	'uint cch;'& _
	'ptr hbmpItem;'

; --- $MENUITEMTEMPLATE
Global Const $MENUITEMTEMPLATE = _
	'ushort mtOption;'& _
	'ushort mtID;'& _
	'wchar  mtString[1];'


; --- $MENUITEMTEMPLATEHEADER
Global Const $MENUITEMTEMPLATEHEADER = _
	'ushort versionNumber;'& _
	'ushort offset;'


; --- $TPMPARAMS
Global Const $TPMPARAMS = _
	'uint cbSize;'& _
	'long rcExclude [4];'



Global Const $MNS_NOCHECK         = 0x80000000
Global Const $MNS_MODELESS        = 0x40000000
Global Const $MNS_DRAGDROP        = 0x20000000
Global Const $MNS_AUTODISMISS     = 0x10000000
Global Const $MNS_NOTIFYBYPOS     = 0x08000000
Global Const $MNS_CHECKORBMP      = 0x04000000


Global Const $OBJID_SYSMENU     =  0xFFFFFFFF;-1
;~ Global Const $OBJID_TITLEBAR    =  0xFFFFFFFE;-2
Global Const $OBJID_MENU        =  0xFFFFFFFD;-3
Global Const $OBJID_CLIENT      =  0xFFFFFFFC;-4
#cs
Global Const $_DFC_MENU	= 2

Global Const $_DFCS_MENUCHECK		= 0x0001
Global Const $_DFCS_MENUBULLET	= 0x0002
#ce
Global Const $HBMMENU_CALLBACK           = -1
Global Const $HBMMENU_SYSTEM             =  1
Global Const $HBMMENU_MBAR_RESTORE       =  2
Global Const $HBMMENU_MBAR_MINIMIZE      =  3
Global Const $HBMMENU_MBAR_CLOSE         =  5
Global Const $HBMMENU_MBAR_CLOSE_D       =  6
Global Const $HBMMENU_MBAR_MINIMIZE_D    =  7
Global Const $HBMMENU_POPUP_CLOSE        =  8
Global Const $HBMMENU_POPUP_RESTORE      =  9
Global Const $HBMMENU_POPUP_MAXIMIZE     = 10
Global Const $HBMMENU_POPUP_MINIMIZE     = 11


Global Const $MIIM_STATE      = 0x00000001
Global Const $MIIM_ID         = 0x00000002
Global Const $MIIM_SUBMENU    = 0x00000004
Global Const $MIIM_CHECKMARKS = 0x00000008
Global Const $MIIM_TYPE       = 0x00000010
Global Const $MIIM_DATA       = 0x00000020
Global Const $MIIM_STRING     = 0x00000040
Global Const $MIIM_BITMAP     = 0x00000080
Global Const $MIIM_FTYPE      = 0x00000100

Global Const $MIM_MAXHEIGHT               = 0x00000001
Global Const $MIM_BACKGROUND              = 0x00000002
Global Const $MIM_HELPID                  = 0x00000004
Global Const $MIM_MENUDATA                = 0x00000008
Global Const $MIM_STYLE                   = 0x00000010
Global Const $MIM_APPLYTOSUBMENUS         = 0x80000000

;/*
; * Menu flags for Add/Check/EnableMenuItem()
; */
Global Const $MF_INSERT           =    0x00000000
Global Const $MF_CHANGE           =    0x00000080
Global Const $MF_APPEND           =    0x00000100
Global Const $MF_DELETE           =    0x00000200
Global Const $MF_REMOVE           =    0x00001000

Global Const $MF_BYCOMMAND        =    0x00000000
Global Const $MF_BYPOSITION       =    0x00000400

Global Const $MF_SEPARATOR        =    0x00000800

Global Const $MF_ENABLED          =    0x00000000
Global Const $MF_GRAYED           =    0x00000001
Global Const $MF_DISABLED         =    0x00000002

Global Const $MF_UNCHECKED        =    0x00000000
Global Const $MF_CHECKED          =    0x00000008
Global Const $MF_USECHECKBITMAPS  =    0x00000200

Global Const $MF_STRING           =    0x00000000
Global Const $MF_BITMAP           =    0x00000004
Global Const $MF_OWNERDRAW        =    0x00000100

Global Const $MF_POPUP            =    0x00000010
Global Const $MF_MENUBARBREAK     =    0x00000020
Global Const $MF_MENUBREAK        =    0x00000040

Global Const $MF_UNHILITE         =    0x00000000
Global Const $MF_HILITE           =    0x00000080

Global Const $MF_DEFAULT          =    0x00001000
Global Const $MF_SYSMENU          =    0x00002000
Global Const $MF_HELP             =    0x00004000
Global Const $MF_RIGHTJUSTIFY     =    0x00004000

Global Const $MF_MOUSESELECT      =    0x00008000


Global Const $MFT_STRING       =  $MF_STRING
Global Const $MFT_BITMAP       =  $MF_BITMAP
Global Const $MFT_MENUBARBREAK =  $MF_MENUBARBREAK
Global Const $MFT_MENUBREAK    =  $MF_MENUBREAK
Global Const $MFT_OWNERDRAW    =  $MF_OWNERDRAW
Global Const $MFT_RADIOCHECK   =  0x00000200
Global Const $MFT_SEPARATOR    =  $MF_SEPARATOR
Global Const $MFT_RIGHTORDER   =  0x00002000
Global Const $MFT_RIGHTJUSTIFY =  $MF_RIGHTJUSTIFY

;/* Menu flags for Add/Check/EnableMenuItem() */
Global Const $MFS_GRAYED      =    0x00000003
Global Const $MFS_DISABLED    =    $MFS_GRAYED
Global Const $MFS_CHECKED     =    $MF_CHECKED
Global Const $MFS_HILITE      =    $MF_HILITE
Global Const $MFS_ENABLED     =    $MF_ENABLED
Global Const $MFS_UNCHECKED   =    $MF_UNCHECKED
Global Const $MFS_UNHILITE    =    $MF_UNHILITE
Global Const $MFS_DEFAULT     =    $MF_DEFAULT


Global Const $TPM_CENTERALIGN		= 4
Global Const $TPM_LEFTALIGN		= 0
Global Const $TPM_RIGHTALIGN		= 8
Global Const $TPM_LEFTBUTTON		= 0
Global Const $TPM_RIGHTBUTTON		= 2
Global Const $TPM_HORIZONTAL		= 0
Global Const $TPM_VERTICAL		= 64
Global Const $TPM_TOPALIGN		= 0
Global Const $TPM_VCENTERALIGN	= 16
Global Const $TPM_BOTTOMALIGN		= 32
Global Const $TPM_NONOTIFY		= 128
Global Const $TPM_RETURNCMD		= 256
Global Const $TPM_RECURSE		= 1
Global Const $TPM_HORPOSANIMATION	= 0x0400
Global Const $TPM_HORNEGANIMATION	= 0x0800
Global Const $TPM_VERPOSANIMATION	= 0x1000
Global Const $TPM_VERNEGANIMATION	= 0x2000
Global Const $TPM_NOANIMATION		= 0x4000
Global Const $TPM_LAYOUTRTL		= 0x8000

Global Const $CCHMAXITEMTEXT = 256


Global $user32dll

If (not $user32dll) Then _
	Global $user32dll = DllOpen ("user32.dll")


OnAutoItExitRegister ("Cleanup")

;

Func AppendMenu ($hMenu, $uFlags, $uIDNewItem, $lpNewItem)

	Local $aRes = DllCall ($user32dll, 'int', 'AppendMenuW', _
								'ptr',      $hMenu, _
								'uint',     $uFlags, _
								'uint_ptr', $uIDNewItem, _
								'wstr',      $lpNewItem)
	Return $aRes[0]

EndFunc

Func CheckMenuItem ($hmenu, $uIDCheckItem, $uCheck)

	Local $aRes = DllCall ($user32dll, 'dword', 'CheckMenuItem', _
								'ptr', $hmenu, _
								'uint', $uIDCheckItem, _
								'uint', $uCheck)



	Return $aRes[0]

EndFunc

Func CheckMenuRadioItem ($hmenu, $idFirst, $idLast, $idCheck, $uFlags)

	Local $aRes = DllCall ($user32dll, 'int', 'CheckMenuRadioItem', _
								'ptr',  $hmenu, _
								'uint', $idFirst, _
								'uint', $idLast, _
								'uint', $idCheck, _
								'uint', $uFlags)



	Return $aRes[0]

EndFunc

Func CreateMenu ( )

	Local $aRes = DllCall ($user32dll, 'ptr', 'CreateMenu')
	Return $aRes[0]

EndFunc

Func CreatePopupMenu ( )

	Local $aRes = DllCall ($user32dll, 'ptr', 'CreatePopupMenu')
	Return $aRes[0]

EndFunc

Func DestroyMenu ($hMenu)

	Local $aRes = DllCall ($user32dll, 'int', 'DestroyMenu', _
								'ptr', $hMenu)
	Return $aRes[0]

EndFunc

Func DrawMenuBar ($hWnd)

	Local $aRes = DllCall ($user32dll, 'int', 'DrawMenuBar', _
								'hwnd', $hWnd)
	Return $aRes[0]

EndFunc

Func EnableMenuItem ($hMenu, $uIDEnableItem, $uEnable)

	Local $aRes = DllCall ($user32dll, 'int', 'EnableMenuItem', _
								'ptr', $hMenu, _
								'uint', $uIDEnableItem, _
								'uint', $uEnable)
	Return $aRes[0]

EndFunc

Func EndMenu ( )

	Local $aRes = DllCall ($user32dll, 'int', 'EndMenu')
	Return $aRes[0]

EndFunc

Func GetMenu ($hWnd)

	Local $aRes = DllCall ($user32dll, 'ptr', 'GetMenu', _
								'hwnd', $hWnd)
	Return $aRes[0]

EndFunc

Func GetMenuBarInfo ($hwnd, $idObject, $idItem, $pmbi)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuBarInfo', _
								'hwnd', $hwnd, _
								'long', $idObject, _
								'long', $idItem, _
								'ptr',  $pmbi)
	Return $aRes[0]

EndFunc

Func GetMenuCheckMarkDimensions ( )

	Local $aRes = DllCall ($user32dll, 'long', 'GetMenuCheckMarkDimensions')
	Return $aRes[0]

EndFunc

Func GetMenuDefaultItem ($hMenu, $fByPos, $gmdiFlags)

	Local $aRes = DllCall ($user32dll, 'uint', 'GetMenuDefaultItem', _
								'ptr', $hMenu, _
								'uint', $fByPos, _
								'uint', $gmdiFlags)
	Return $aRes[0]

EndFunc

Func GetMenuInfo ($hmenu, $lpcmi)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuInfo', _
								'ptr', $hmenu, _
								'ptr', $lpcmi)
	Return $aRes[0]

EndFunc

Func GetMenuItemCount ($hMenu)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuItemCount', _
								'ptr', $hMenu)
	Return $aRes[0]

EndFunc

Func GetMenuItemInfo ($hMenu, $uItem, $fByPosition, $lpmii)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuItemInfoW', _
								'ptr',  $hMenu, _
								'uint', $uItem, _
								'int',  $fByPosition, _
								'ptr',  $lpmii)
	Return $aRes[0]

EndFunc

Func GetMenuItemRect ($hWnd, $hMenu, $uItem, $lprcItem)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuItemRect', _
								'hwnd', $hWnd, _
								'ptr', $hMenu, _
								'uint', $uItem, _
								'ptr', $lprcItem)
	Return $aRes[0]

EndFunc

Func GetMenuState ($hMenu, $uId, $uFlags)

	Local $aRes = DllCall ($user32dll, 'uint', 'GetMenuState', _
								'ptr', $hMenu, _
								'uint', $uId, _
								'uint', $uFlags)
	Return $aRes[0]

EndFunc

Func GetMenuString ($hMenu, $uIDItem, ByRef $sString, $nMaxCount, $uFlag)

	Local $aRes = DllCall ($user32dll, 'int', 'GetMenuStringW', _
								'ptr',  $hMenu, _
								'uint', $uIDItem, _
								'wstr', $sString, _
								'int',  $nMaxCount, _
								'uint', $uFlag)
	$sString = $aRes[3]
	Return $aRes[0]

EndFunc

Func GetSubMenu ($hMenu, $nPos)

	Local $aRes = DllCall ($user32dll, 'ptr', 'GetSubMenu', _
								'ptr', $hMenu, _
								'int', $nPos)
	Return $aRes[0]

EndFunc

Func GetSystemMenu ($hWnd, $bRevert)

	Local $aRes = DllCall ($user32dll, 'ptr', 'GetSystemMenu', _
								'hwnd', $hWnd, _
								'int', $bRevert)
	Return $aRes[0]

EndFunc

Func HiliteMenuItem ($hwnd, $hmenu, $uItemHilite, $uHilite)

	Local $aRes = DllCall ($user32dll, 'int', 'HiliteMenuItem', _
								'hwnd', $hwnd, _
								'ptr', $hmenu, _
								'uint', $uItemHilite, _
								'uint', $uHilite)
	Return $aRes[0]

EndFunc

Func InsertMenuItem ($hMenu, $uItem, $fByPosition, $lpmii)

	Local $aRes = DllCall ($user32dll, 'int', 'InsertMenuItemW', _
								'ptr',  $hMenu, _
								'uint', $uItem, _
								'int',  $fByPosition, _
								'ptr',  $lpmii)
	Return $aRes[0]

EndFunc

Func IsMenu ($hMenu)

	Local $aRes = DllCall ($user32dll, 'int', 'IsMenu', _
								'ptr', $hMenu)
	Return $aRes[0]

EndFunc

Func LoadMenu ($hInstance, $sMenuName)

	Local $aRes = DllCall ($user32dll, 'ptr', 'LoadMenuW', _
								'ptr', $hInstance, _
								'wstr', $sMenuName)
	Return $aRes[0]

EndFunc

Func LoadMenuIndirect ($lpMenuTemplate)

	Local $aRes = DllCall ($user32dll, 'ptr', 'LoadMenuIndirectW', _
								'ptr', $lpMenuTemplate)
	Return $aRes[0]

EndFunc

Func MenuItemFromPoint ($hWnd, $hMenu, $ptScreen)

	Local $aRes = DllCall ($user32dll, 'int', 'MenuItemFromPoint', _
								'hwnd', $hWnd, _
								'ptr', $hMenu, _
								'POINT', $ptScreen)
	Return $aRes[0]

EndFunc

Func ModifyMenu ($hMenu, $uPosition, $uFlags, $uIDNewItem, $sNewItem)

	Local $aRes = DllCall ($user32dll, 'int', 'ModifyMenuW', _
								'ptr',  $hMenu, _
								'uint', $uPosition, _
								'uint', $uFlags, _
								'ptr',  $uIDNewItem, _
								'wstr', $sNewItem)
	Return $aRes[0]

EndFunc

Func RemoveMenu ($hMenu, $uPosition, $uFlags)

	Local $aRes = DllCall ($user32dll, 'int', 'RemoveMenu', _
								'ptr', $hMenu, _
								'uint', $uPosition, _
								'uint', $uFlags)
	Return $aRes[0]

EndFunc

Func SetMenuDefaultItem ($hMenu, $uItem, $fByPos)

	Local $aRes = DllCall ($user32dll, 'int', 'SetMenuDefaultItem', _
								'ptr', $hMenu, _
								'uint', $uItem, _
								'uint', $fByPos)
	Return $aRes[0]

EndFunc

Func SetMenu ($hWnd, $hMenu)

	Local $aRes = DllCall ($user32dll, 'int', 'SetMenu', _
								'hwnd', $hWnd, _
								'ptr',  $hMenu)
	Return $aRes[0]

EndFunc

Func SetMenuInfo ($hmenu, $lpcmi)

	Local $aRes = DllCall ($user32dll, 'int', 'SetMenuInfo', _
								'ptr', $hmenu, _
								'ptr', $lpcmi)
	Return $aRes[0]

EndFunc

Func SetMenuItemBitmaps ($hMenu, $uPosition, $uFlags, $hBitmapUnchecked, $hBitmapChecked)

	Local $aRes = DllCall ($user32dll, 'int', 'SetMenuItemBitmaps', _
								'ptr', $hMenu, _
								'uint', $uPosition, _
								'uint', $uFlags, _
								'ptr', $hBitmapUnchecked, _
								'ptr', $hBitmapChecked)
	Return $aRes[0]

EndFunc

Func SetMenuItemInfo ($hMenu, $uItem, $fByPosition, $lpmii)

	Local $aRes = DllCall ($user32dll, 'int', 'SetMenuItemInfoW', _
								'ptr',  $hMenu, _
								'uint', $uItem, _
								'int',  $fByPosition, _
								'ptr',  $lpmii)
	Return $aRes[0]

EndFunc

Func TrackPopupMenu ($hMenu, $uFlags, $x, $y, $nReserved, $hWnd, $prcRect)

	Local $aRes = DllCall ($user32dll, 'int', 'TrackPopupMenu', _
								'ptr', $hMenu, _
								'uint', $uFlags, _
								'int', $x, _
								'int', $y, _
								'int', $nReserved, _
								'hwnd', $hWnd, _
								'hwnd', $prcRect)
	Return $aRes[0]

EndFunc

Func TrackPopupMenuEx ($hmenu, $fuFlags, $x, $y, $hwnd, $lptpm)

	Local $aRes = DllCall ($user32dll, 'int', 'TrackPopupMenuEx', _
								'ptr', $hmenu, _
								'uint', $fuFlags, _
								'int', $x, _
								'int', $y, _
								'hwnd', $hwnd, _
								'ptr', $lptpm)
	Return $aRes[0]

EndFunc

;

Func Cleanup ( )

	DllClose ($user32dll)

EndFunc



